CREATE TABLE cleanup_expired_config
(
  TABLE_NAME            VARCHAR2(128) NOT NULL,
  REFERENCE_COLUMN      VARCHAR2(50)  NOT NULL,
  REFERENCE_COLUMN_UNIT VARCHAR2(20)  NOT NULL,
  CLEANUP_METHOD        VARCHAR2(50)  NOT NULL,
  RETENTION_TIME        NUMBER        NOT NULL,
  RETENTION_UNIT        VARCHAR2(10)  NOT NULL,
  TRIGGERED_BY          VARCHAR2(10)  NOT NULL
)
LOGGING
TABLESPACE SYSTEM;

ALTER TABLE cleanup_expired_config 
  ADD CONSTRAINT PK_cleanup_expired_config
    PRIMARY KEY (TABLE_NAME)
      USING INDEX TABLESPACE SYSTEM LOGGING ENABLE VALIDATE;

ALTER TABLE cleanup_expired_config ADD (
  CHECK ((RETENTION_TIME > 0 AND CLEANUP_METHOD <> 'TRUNCATE_TABLE') OR (RETENTION_TIME = 0 AND CLEANUP_METHOD = 'TRUNCATE_TABLE'))
  ENABLE VALIDATE);

ALTER TABLE cleanup_expired_config ADD (
  CHECK (CLEANUP_METHOD IN ('DELETE_ROWS','TRUNCATE_TABLE','DROP_INTERVAL_PARTITIONS'))
  ENABLE VALIDATE);

ALTER TABLE cleanup_expired_config ADD (
  CHECK (TRIGGERED_BY IN ('EXTERNAL','DATABASE'))
  ENABLE VALIDATE);

ALTER TABLE cleanup_expired_config ADD (
  CHECK (REFERENCE_COLUMN_UNIT IN ('N/A','SECONDS','MILLISECONDS'))
  ENABLE VALIDATE);

ALTER TABLE cleanup_expired_config ADD (
  CHECK (RETENTION_UNIT IN ('DAY','MONTH','YEAR'))
  ENABLE VALIDATE);
  
